/****************************************************************************/
/** Palette Routines for Vision-8 GB                                       **/
/** by Haroldo de Oliveira Pinheiro                                        **/
/****************************************************************************/

#include <gb.h>

#define _CGB_RGB(R,G,B) ((B << 10)|(G << 5)|R)

UWORD default_bkg_palette[]={
_CGB_RGB(0x00L,0x00L,0x00L),
_CGB_RGB(0x00L,0x00L,0x00L),
_CGB_RGB(0x00L,0x00L,0x00L),
_CGB_RGB(0x00L,0x1FL,0x00L),
//
_CGB_RGB(0x1FL,0x1FL,0x1FL),
_CGB_RGB(0x0FL,0x0FL,0x0FL),
_CGB_RGB(0x08L,0x08L,0x08L),
_CGB_RGB(0x00L,0x00L,0x00L),
// 
_CGB_RGB(0x1FL,0x0FL,0x0FL),
_CGB_RGB(0x0FL,0x08L,0x08L),
_CGB_RGB(0x08L,0x04L,0x04L),
_CGB_RGB(0x00L,0x00L,0x00L),
//
_CGB_RGB(0x0FL,0x0FL,0x1FL),
_CGB_RGB(0x08L,0x08L,0x0FL),
_CGB_RGB(0x04L,0x04L,0x08L),
_CGB_RGB(0x00L,0x00L,0x00L),
};

UWORD wallpaper_palettes[]={
// 1
_CGB_RGB(0x1FL,0x0FL,0x07L),
_CGB_RGB(0x0FL,0x07L,0x04L),
_CGB_RGB(0x08L,0x04L,0x04L),
_CGB_RGB(0x07L,0x07L,0x07L),
// 2
_CGB_RGB(0x1FL,0x1FL,0x1FL),
_CGB_RGB(0x00L,0x00L,0x0FL),
_CGB_RGB(0x08L,0x08L,0x18L),
_CGB_RGB(0x0FL,0x0FL,0x00L),
// 3
_CGB_RGB(0x18L,0x18L,0x00L),
_CGB_RGB(0x0FL,0x0FL,0x00L),
_CGB_RGB(0x08L,0x08L,0x00L),
_CGB_RGB(0x00L,0x00L,0x00L),
// 4
_CGB_RGB(0x00L,0x1FL,0x1FL),
_CGB_RGB(0x00L,0x0FL,0x0FL),
_CGB_RGB(0x00L,0x08L,0x08L),
_CGB_RGB(0x00L,0x00L,0x00L),
// 5
_CGB_RGB(0x10L,0x08L,0x1FL),
_CGB_RGB(0x08L,0x04L,0x0FL),
_CGB_RGB(0x04L,0x02L,0x08L),
_CGB_RGB(0x02L,0x00L,0x04L),
// 6
_CGB_RGB(0x1FL,0x1FL,0x1FL),
_CGB_RGB(0x0FL,0x0FL,0x0FL),
_CGB_RGB(0x08L,0x08L,0x08L),
_CGB_RGB(0x00L,0x00L,0x00L),
// 7
_CGB_RGB(0x1FL,0x1FL,0x1FL),
_CGB_RGB(0x08L,0x08L,0x1FL),
_CGB_RGB(0x02L,0x02L,0x0FL),
_CGB_RGB(0x00L,0x00L,0x00L),
// 8
_CGB_RGB(0x1FL,0x1FL,0x1FL),
_CGB_RGB(0x0FL,0x0FL,0x00L),
_CGB_RGB(0x08L,0x00L,0x00L),
_CGB_RGB(0x00L,0x00L,0x00L),
// 9
_CGB_RGB(0x1FL,0x1FL,0x1FL),
_CGB_RGB(0x0FL,0x00L,0x00L),
_CGB_RGB(0x08L,0x00L,0x00L),
_CGB_RGB(0x00L,0x00L,0x00L),
// 10
_CGB_RGB(0x00L,0x1DL,0x00L),
_CGB_RGB(0x00L,0x0FL,0x00L),
_CGB_RGB(0x00L,0x08L,0x00L),
_CGB_RGB(0x00L,0x00L,0x00L),
// 11
_CGB_RGB(0x18L,0x1FL,0x08L),
_CGB_RGB(0x07L,0x0FL,0x04L),
_CGB_RGB(0x04L,0x08L,0x02L),
_CGB_RGB(0x00L,0x02L,0x00L),
// 12
_CGB_RGB(0x1FL,0x1FL,0x1FL),
_CGB_RGB(0x0FL,0x0FL,0x0FL),
_CGB_RGB(0x08L,0x08L,0x08L),
_CGB_RGB(0x00L,0x00L,0x00L),
// 13
_CGB_RGB(0x1FL,0x1FL,0x1FL),
_CGB_RGB(0x0FL,0x0FL,0x0FL),
_CGB_RGB(0x08L,0x08L,0x08L),
_CGB_RGB(0x00L,0x00L,0x00L),
// 14
_CGB_RGB(0x1FL,0x1FL,0x1FL),
_CGB_RGB(0x0FL,0x0FL,0x0FL),
_CGB_RGB(0x08L,0x08L,0x08L),
_CGB_RGB(0x00L,0x00L,0x00L),
// 15
_CGB_RGB(0x1FL,0x1FL,0x1FL),
_CGB_RGB(0x0FL,0x0FL,0x0FL),
_CGB_RGB(0x08L,0x08L,0x08L),
_CGB_RGB(0x00L,0x00L,0x00L),
// 16
_CGB_RGB(0x1FL,0x1FL,0x1FL),
_CGB_RGB(0x0FL,0x0FL,0x0FL),
_CGB_RGB(0x08L,0x08L,0x08L),
_CGB_RGB(0x00L,0x00L,0x00L),
};

void load_default_pal(){
   UWORD *p;
   UBYTE i;

   p = default_bkg_palette;
   for(i = 3; i != 8; i++){
      set_bkg_palette(i,1,p);
      p += 4;
   }
}
